unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, XPMan;

const
  COMMENT = 'Venus Level';
  VERSION = 3;

type
  TEvent = record
    index, val1, val2, val3, val4, val5: byte;
    str: string;
  end;

  TFrmMain = class(TForm)
  published
    GrpEvents: TGroupBox;
    LstEvents: TListBox;
    BtnEventUp: TButton;
    BtnEventDown: TButton;
    BtnEventDel: TButton;
    MnuMain: TMainMenu;
    File1: TMenuItem;
    GrpNew: TGroupBox;
    BtnEventAdd: TButton;
    BtnEventReplace: TButton;
    CmbEventType: TComboBox;
    CmbEventVal3: TComboBox;
    EdtEventVal1: TEdit;
    LblEventType: TLabel;
    LblEventArg1: TLabel;
    CmbEventVal2: TComboBox;
    LblEventArg2: TLabel;
    LblEventArg3: TLabel;
    ScbEventVal1: TScrollBar;
    LblEventVal1: TLabel;
    LblEventArg4: TLabel;
    CmbEventVal4: TComboBox;
    ScbEventVal5: TScrollBar;
    LblEventArg5: TLabel;
    LblEventVal5: TLabel;
    XPManifest1: TXPManifest;
    Newlevel1: TMenuItem;
    Openlevel1: TMenuItem;
    Saveas1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    DlgOpen: TOpenDialog;
    DlgSave: TSaveDialog;
    Settings1: TMenuItem;

    procedure FormShow(Sender: TObject);

    procedure Newlevel1Click(Sender: TObject);
    procedure Openlevel1Click(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Settings1Click(Sender: TObject);

    procedure LstEventsList(Sender: TObject);
    procedure LstEventsClick(Sender: TObject);
    procedure CmbEventTypeChange(Sender: TObject);
    procedure CmbEventVal4Change(Sender: TObject);
    procedure ScbEventVal1Change(Sender: TObject);
    procedure ScbEventVal5Change(Sender: TObject);

    procedure BtnEventUpClick(Sender: TObject);
    procedure BtnEventDownClick(Sender: TObject);
    procedure BtnEventDelClick(Sender: TObject);
    procedure BtnEventAddClick(Sender: TObject);
    procedure BtnEventReplaceClick(Sender: TObject);
  end;

var
  FrmMain: TFrmMain;
  eventCount: integer;
  fileName: string;
  eventList: array of TEvent;

implementation

uses About, Settings;

{$R *.dfm}



{ Form creation }
procedure TFrmMain.FormShow(Sender: TObject);
begin
  Newlevel1Click(Sender);
end;



{ File  New level }
procedure TFrmMain.Newlevel1Click(Sender: TObject);
begin
  Randomize();
  fileName := '';

  eventCount := 0;

  FrmSettings.EdtSettingDesc.Text := 'Venus Level';
  FrmSettings.EdtSettingFile.Text := 'vnslevel';
  FrmSettings.EdtSettingFold.Text := 'main';

  LstEventsList(Sender);
  CmbEventTypeChange(Sender);
  CmbEventVal4Change(Sender);
end;



{ File  Open level }
procedure TFrmMain.Openlevel1Click(Sender: TObject);
var
  i: integer;
  s: string;
  handle: file;
  buffer: array [0 .. 39] of byte;
  data: array [0 .. 65535] of byte;
begin
  if (DlgOpen.Execute) then
  begin
    fileMode := fmOpenRead;
    fileName := DlgOpen.FileName;
    AssignFile(handle,fileName);
    Reset(handle,1);
    BlockRead(handle,buffer,8); // **TI92P*
    BlockRead(handle,buffer,2); // Separator

    BlockRead(handle,buffer,8); // Folder Name
    s := '';
    for i := 0 to 7 do
      s := s + char(buffer[i]);
    FrmSettings.EdtSettingFold.Text := s;

    BlockRead(handle,buffer,40); // Comment
    BlockRead(handle,buffer,6); // Separator

    BlockRead(handle,buffer,8); // File Name
    s := '';
    for i := 0 to 7 do
      s := s + char(buffer[i]);
    FrmSettings.EdtSettingFile.Text := s;

    BlockRead(handle,buffer,4); // ? - State - ? - ?
    BlockRead(handle,buffer,4); // File Length
    BlockRead(handle,buffer,6); // Separator
    BlockRead(handle,buffer,2); // Data Length
    i := buffer[0] shl 8 + buffer[1];
    BlockRead(handle,data,i); // Data
    CloseFile(handle);

    if (data[0] = 2) then
    begin
      ShowMessage('This level was version 2, upgraded to version 3');
      data[0] := 3;      
    end;

    if (data[0] = VERSION) then
    begin
      eventCount := 0;
      i := 6; // Skip version, free, and ID number
      s := '';

      // Read description
      while (data[i] > 0) do
      begin
        s := s + char(data[i]);
        Inc(i);
      end;

      FrmSettings.EdtSettingDesc.Text := s;
      Inc(i);

      // Read events
      while (data[i] > 0) do
      begin
        if (Length(eventList) = eventCount) then
          SetLength(eventList,eventCount + 10);

        eventList[eventCount].index := data[i] - 1;
        Inc(eventCount);

        case (data[i]) of
          1:
          begin
            Inc(i);
            s := '';

            while (data[i] > 0) do
            begin
              s := s + char(data[i]);
              Inc(i);
            end;

            with (eventList[eventCount - 1]) do
            begin
              str := s;
              val4 := data[i + 1] - 1;
              val5 := data[i + 2];
            end;

            Inc(i,3);
          end;

          2:
          begin
            with (eventList[eventCount - 1]) do
            begin
              val1 := data[i + 1];
            end;

            Inc(i,2);
          end;

          3:
          begin
            Inc(i);
          end;

          4:
          begin
            with (eventList[eventCount - 1]) do
            begin
              val1 := data[i + 1];
              val4 := data[i + 2] - 1;
              val5 := data[i + 3];
            end;

            Inc(i,4);
          end;

          5:
          begin
            with (eventList[eventCount - 1]) do
            begin
              val1 := data[i + 1];
              val2 := data[i + 2];
              val3 := data[i + 3];
              val4 := data[i + 4] - 1;
              val5 := data[i + 5];
            end;

            Inc(i,6);
          end;

          else
          begin
            ShowMessage('Error while reading level ' + IntToStr(data[i]));
            Exit;
          end;
        end;
      end;

      LstEventsList(Sender);
    end
    else
    begin
      ShowMessage('Incompatible level version');
    end;
  end;
end;



{ File  Save as... }
procedure TFrmMain.Saveas1Click(Sender: TObject);
begin
  fileName := '';

  Save1Click(Sender);
end;



{ File  Save }
procedure TFrmMain.Save1Click(Sender: TObject);
var
  i, idxFile, idxVar, j, k: integer;
  eventId: cardinal;
  handle: file;
  data: array [0 .. 65535] of byte;
begin
  if (fileName = '') and (DlgSave.Execute) then
    fileName := DlgSave.FileName;

  if (fileName <> '') then
  begin
    i := 0;

    for j := 1 to 8 do
    begin
      data[i] := Ord('**TI92P*'[j]);
      Inc(i);
    end;

    data[i + 0] := $01;
    data[i + 1] := $00;
    Inc(i,2);

    for j := 1 to Length(FrmSettings.EdtSettingFold.Text) do
    begin
      data[i] := Ord(FrmSettings.EdtSettingFold.Text[j]);
      Inc(i);
    end;

    for j := Length(FrmSettings.EdtSettingFold.Text) + 1 to 8 do
    begin
      data[i] := 0;
      Inc(i);
    end;

    for j := 1 to Length(COMMENT) do
    begin
      data[i] := Ord(COMMENT[j]);
      Inc(i);
    end;

    for j := Length(COMMENT) + 1 to 40 do
    begin
      data[i] := 0;
      Inc(i);
    end;

    data[i + 0] := $01;
    data[i + 1] := $00;
    data[i + 2] := $52;
    data[i + 3] := $00;
    data[i + 4] := $00;
    data[i + 5] := $00;
    Inc(i,6);

    for j := 1 to Length(FrmSettings.EdtSettingFile.Text) do
    begin
      data[i] := Ord(FrmSettings.EdtSettingFile.Text[j]);
      Inc(i);
    end;

    for j := Length(FrmSettings.EdtSettingFile.Text) + 1 to 8 do
    begin
      data[i] := 0;
      Inc(i);
    end;

    data[i + 0] := $1C;
    data[i + 1] := $00;
    data[i + 2] := $00;
    data[i + 3] := $00;
    Inc(i,4);

    idxFile := i;
    Inc(i,4);

    data[i + 0] := $A5;
    data[i + 1] := $5A;
    data[i + 2] := $00;
    data[i + 3] := $00;
    data[i + 4] := $00;
    data[i + 5] := $00;
    Inc(i,6);

    idxVar := i;
    Inc(i,2);

    data[i + 0] := VERSION;
    data[i + 1] := 0;
    Inc(i,2);

    eventId := Random(High(cardinal));
    data[i + 0] := eventId and 255;
    data[i + 1] := eventId shr 8;
    data[i + 2] := eventId shr 16;
    data[i + 3] := eventId shr 24;
    Inc(i,4);

    for j := 1 to Length(FrmSettings.EdtSettingDesc.Text) do
    begin
      data[i] := Ord(FrmSettings.EdtSettingDesc.Text[j]);
      Inc(i);
    end;

    data[i + 0] := 0;
    Inc(i);

    for j := 0 to eventCount - 1 do
    begin
      with (eventList[j]) do
      begin
        data[i + 0] := index + 1;

        case (index) of
          0:
          begin
            Inc(i);

            for k := 1 to Length(str) do
            begin
              data[i] := Ord(str[k]);
              Inc(i);
            end;

            data[i + 0] := 0;
            data[i + 1] := val4 + 1;
            if (val4 = 0) then
              data[i + 2] := val5
            else
              data[i + 2] := 0;
            Inc(i,3);
          end;

          1:
          begin
            data[i + 1] := val1;
            Inc(i,2);
          end;

          2:
          begin
            Inc(i);
          end;

          3:
          begin
            data[i + 1] := val1;
            data[i + 2] := val4 + 1;
            if (val4 = 0) then
              data[i + 3] := val5
            else
              data[i + 3] := 1;
            Inc(i,4);
          end;

          4:
          begin
            data[i + 1] := val1;
            data[i + 2] := val2;
            data[i + 3] := val3;
            data[i + 4] := val4 + 1;
            if (val4 = 0) then
              data[i + 5] := val5
            else
              data[i + 5] := 2;
            Inc(i,6);
          end;
        end;
      end;
    end;

    data[i + 0] := 0;
    data[i + 1] := Ord('V');
    data[i + 2] := Ord('S');
    data[i + 3] := Ord('L');
    data[i + 4] := 0;
    data[i + 5] := 248;
    Inc(i,6);

    j := i - idxVar - 2;
    data[idxVar + 0] := j shr 8;
    data[idxVar + 1] := j and 255;

    j := j + 88 + 2;
    data[idxFile + 0] := j and 255;
    data[idxFile + 1] := j shr 8;
    data[idxFile + 2] := j shr 16;
    data[idxFile + 3] := j shr 24;

    k := 0;

    for j := idxVar to i - 1 do
      Inc(k,data[j]);

    data[i + 0] := k and $FF;
    data[i + 1] := (k shr 8) and $FF;
    Inc(i,2);

    AssignFile(handle,fileName);
    Rewrite(handle,1);
    BlockWrite(handle,data,i);
    CloseFile(handle);
  end;
end;



{ File  Exit }
procedure TFrmMain.Exit1Click(Sender: TObject);
begin
  Application.Terminate();
end;



{ Settings }
procedure TFrmMain.Settings1Click(Sender: TObject);
begin
  FrmSettings.Show();
  Enabled := false;

  while (FrmSettings.Visible) do
    Application.ProcessMessages();
end;



{ About }
procedure TFrmMain.About1Click(Sender: TObject);
begin
  FrmAbout.Show();
  Enabled := false;

  while (FrmAbout.Visible) do
    Application.ProcessMessages();
end;



{ List all events }
procedure TFrmMain.LstEventsList(Sender: TObject);
var
  i, s: integer;
begin
  s := LstEvents.ItemIndex;

  LstEvents.Clear();

  for i := 0 to eventCount - 1 do
    LstEvents.Items.Add(IntToStr(i + 1) + ' - ' + CmbEventType.Items.Strings[eventList[i].index]);

  if (LstEvents.Items.Count > s) then
    LstEvents.ItemIndex := s;
end;



{ Select recorded event }
procedure TFrmMain.LstEventsClick(Sender: TObject);
begin
  if (LstEvents.ItemIndex > - 1) then
  begin
    with (eventList[LstEvents.ItemIndex]) do
    begin
      EdtEventVal1.Text := str;
      CmbEventType.ItemIndex := index;
      ScbEventVal1.Position := val1;
      CmbEventVal2.ItemIndex := val2;
      CmbEventVal3.ItemIndex := val3;
      CmbEventVal4.ItemIndex := val4;
      ScbEventVal5.Position := val5;
    end;

    CmbEventTypeChange(Sender);
    BtnEventDel.Enabled := true;
    BtnEventReplace.Enabled := true;
  end
  else
  begin
    BtnEventUp.Enabled := false;
    BtnEventDown.Enabled := false;
    BtnEventDel.Enabled := false;
    BtnEventReplace.Enabled := false;
  end;
end;



{ Change event type }
procedure TFrmMain.CmbEventTypeChange(Sender: TObject);
var
  arg1, arg2: integer;
begin
  arg1 := 0;
  arg2 := 0;

  case (CmbEventType.ItemIndex) of
    0:
    begin
      LblEventArg1.Caption := 'Message :';
      EdtEventVal1.Enabled := true;
      EdtEventVal1.Visible := true;
      ScbEventVal1.Visible := false;
      LblEventVal1.Visible := false;
      arg1 := 1;
      LblEventArg4.Caption := 'Call next :';
      arg2 := 1;
    end;

    1:
    begin
      LblEventArg1.Caption := 'Frames :';
      EdtEventVal1.Visible := false;
      ScbEventVal1.Enabled := true;
      ScbEventVal1.Visible := true;
      LblEventVal1.Enabled := true;
      LblEventVal1.Visible := true;
      arg1 := 1;
    end;

    3:
    begin
      LblEventArg1.Caption := 'Speed :';
      EdtEventVal1.Visible := false;
      ScbEventVal1.Enabled := true;
      ScbEventVal1.Visible := true;
      LblEventVal1.Enabled := true;
      LblEventVal1.Visible := true;
      arg1 := 1;
      LblEventArg4.Caption := 'Call next :';
      arg2 := 1;
    end;

    4:
    begin
      LblEventArg1.Caption := 'Ships :';
      EdtEventVal1.Visible := false;
      ScbEventVal1.Enabled := true;
      ScbEventVal1.Visible := true;
      LblEventVal1.Enabled := true;
      LblEventVal1.Visible := true;
      LblEventArg2.Caption := 'Type :';
      LblEventArg3.Caption := 'Movement :';
      arg1 := 3;
      LblEventArg4.Caption := 'Call next :';
      arg2 := 1;
    end;
  end;

  if (arg1 < 1) then
  begin
    LblEventArg1.Caption := '-';
    LblEventArg1.Enabled := false;
    LblEventVal1.Caption := '-';
    LblEventVal1.Enabled := false;
    EdtEventVal1.Enabled := false;
    ScbEventVal1.Enabled := false;
  end
  else
  begin
    LblEventArg1.Enabled := true;
    ScbEventVal1Change(Sender);
  end;

  if (arg1 < 2) then
  begin
    LblEventArg2.Caption := '-';
    LblEventArg2.Enabled := false;
    CmbEventVal2.Enabled := false;
  end
  else
  begin
    LblEventArg2.Enabled := true;
    CmbEventVal2.Enabled := true;
  end;

  if (arg1 < 3) then
  begin
    LblEventArg3.Caption := '-';
    LblEventArg3.Enabled := false;
    CmbEventVal3.Enabled := false;
  end
  else
  begin
    CmbEventVal3.Enabled := true;
    LblEventArg3.Enabled := true;
  end;

  if (arg2 < 1) then
  begin
    LblEventArg4.Caption := '-';
    CmbEventVal4.Enabled := false;
    LblEventArg4.Enabled := false;
    CmbEventVal4Change(Sender);
  end
  else
  begin
    LblEventArg4.Enabled := true;
    CmbEventVal4.Enabled := true;
    CmbEventVal4Change(Sender);
  end;
end;



{ Change event end }
procedure TFrmMain.CmbEventVal4Change(Sender: TObject);
var
  arg: integer;
begin
  arg := 0;

  if (CmbEventVal4.Enabled) then
  begin
    case (CmbEventVal4.ItemIndex) of
      0:
      begin
        LblEventArg5.Caption := 'Frames :';
        arg := 1;
      end;

      1:
      begin
        arg := 0;
      end;
    end;
  end;

  if (arg < 1) then
  begin
    LblEventArg5.Caption := '-';
    LblEventArg5.Enabled := false;
    LblEventVal5.Caption := '-';
    LblEventVal5.Enabled := false;
    ScbEventVal5.Enabled := false;
  end
  else
  begin
    LblEventArg5.Enabled := true;
    LblEventVal5.Enabled := true;
    ScbEventVal5.Enabled := true;
    ScbEventVal5Change(Sender);
  end;
end;



{ Change argument 1 value }
procedure TFrmMain.ScbEventVal1Change(Sender: TObject);
begin
  LblEventVal1.Caption := IntToStr(ScbEventVal1.Position);
end;



{ Change argument 5 value }
procedure TFrmMain.ScbEventVal5Change(Sender: TObject);
begin
  LblEventVal5.Caption := IntToStr(ScbEventVal5.Position);
end;



{ Move event up }
procedure TFrmMain.BtnEventUpClick(Sender: TObject);
var
  s: integer;
  swap: TEvent;
begin
  if (LstEvents.ItemIndex > 0) then
  begin
    s := LstEvents.ItemIndex;
    swap := eventList[LstEvents.ItemIndex];
    eventList[LstEvents.ItemIndex] := eventList[LstEvents.ItemIndex - 1];
    eventList[LstEvents.ItemIndex - 1] := swap;

    LstEventsList(Sender);
    LstEvents.ItemIndex := s - 1;
  end;
end;



{ Move event down }
procedure TFrmMain.BtnEventDownClick(Sender: TObject);
var
  s: integer;
  swap: TEvent;
begin
  if (LstEvents.ItemIndex > - 1) and (LstEvents.ItemIndex < LstEvents.Items.Count - 1) then
  begin
    s := LstEvents.ItemIndex;
    swap := eventList[LstEvents.ItemIndex];
    eventList[LstEvents.ItemIndex] := eventList[LstEvents.ItemIndex + 1];
    eventList[LstEvents.ItemIndex + 1] := swap;

    LstEventsList(Sender);
    LstEvents.ItemIndex := s + 1;
  end;
end;



{ Del event }
procedure TFrmMain.BtnEventDelClick(Sender: TObject);
var
  i: integer;
begin
  if (LstEvents.ItemIndex > - 1) then
  begin
    for i := LstEvents.ItemIndex to eventCount - 2 do
      eventList[i] := eventList[i + 1];

    Dec(eventCount);
    LstEventsList(Sender);
    LstEvents.ItemIndex := - 1;
  end;
end;



{ Add new event }
procedure TFrmMain.BtnEventAddClick(Sender: TObject);
begin
  if (Length(eventList) = eventCount) then
    SetLength(eventList,eventCount + 10);

  with (eventList[eventCount]) do
  begin
    index := CmbEventType.ItemIndex;
    str := EdtEventVal1.Text;
    val1 := ScbEventVal1.Position;
    val2 := CmbEventVal2.ItemIndex;
    val3 := CmbEventVal3.ItemIndex;
    val4 := CmbEventVal4.ItemIndex;
    val5 := ScbEventVal5.Position;
  end;

  Inc(eventCount);
  LstEventsList(Sender);
  LstEvents.ItemIndex := eventCount - 1;
end;



{ Replace event }
procedure TFrmMain.BtnEventReplaceClick(Sender: TObject);
begin
  if (LstEvents.ItemIndex > - 1) then
  begin
    with (eventList[LstEvents.ItemIndex]) do
    begin
      index := CmbEventType.ItemIndex;
      str := EdtEventVal1.Text;
      val1 := ScbEventVal1.Position;
      val2 := CmbEventVal2.ItemIndex;
      val3 := CmbEventVal3.ItemIndex;
      val4 := CmbEventVal4.ItemIndex;
      val5 := ScbEventVal5.Position;
    end;

    LstEventsList(Sender);
  end;
end;

end.
