////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                   Macros and Defines                   //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^ Compilation Switchs ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

// #define SWITCH_CPU_USAGE  // Show CPU usage in the game
// #define SWITCH_DBUFFERING // Enable Double Buffering but disable transitions
#define SWITCH_TI89       // Use a Ti89 160*100 screen instead of a Ti92+/v200 240*128 screen



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Addon ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define ADDON_COUNT 3
#define ADDON_DEFLECTOR 0
#define ADDON_TELEPORT_DISTANCE 8
#define ADDON_MAGNETIC 1
#define ADDON_MAGNETIC_DISTANCE (8 << COEF_SCREEN_TO_ZONE)
#define ADDON_MAGNETIC_SPEED 3
#define ADDON_TELEPORT 2



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Bonus ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define BONUS_COUNT 4
#define BONUS_PROB_HIGH 10
#define BONUS_PROB_LOW 90
#define BONUS_PROB_MED 30
#define BONUS_RADIUS (10 << COEF_SCREEN_TO_ZONE)
#define BONUS_SIZE (16 << COEF_SCREEN_TO_ZONE)
#define BONUS_SPEED 32



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Bullet ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define BULLET_COUNT 64
#define BULLET_SIZE (8 << COEF_SCREEN_TO_ZONE)



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^ Coefficients ^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define COEF_SCREEN_TO_ZONE 4



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Effect ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define EFFECT_COUNT 16
#define EFFECT_SIZE (32 << COEF_SCREEN_TO_ZONE)



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Event ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define EVENT_VERSION 3
#define EVENT_END 0
#define EVENT_MESSAGE 1
#define EVENT_PAUSE 2
#define EVENT_SHOP 3
#define EVENT_STAR 4
#define EVENT_WAVE 5
#define EVENT_END_NONE 0
#define EVENT_END_PAUSE 1
#define EVENT_END_WAIT 2
#define EVENT_WAIT_MESSAGE 0
#define EVENT_WAIT_STAR 1
#define EVENT_WAIT_WAVE 2



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Fleet ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define FLEET_COUNT 11



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Key ^^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define KEY_COUNT 8
#define KEY_DELAY 4



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Location ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define LOCATION_BULLET_COUNT 10
#define LOCATION_SHIP_COUNT 5



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Menu ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define MENU_ERASE_Y 4
#define MENU_ITEM_COUNT 64
#define MENU_LINE_COUNT 5
#define MENU_SHIFT_LOGO (6 + SCREEN_SHIFT_Y)
#define MENU_SHIFT_X (80 + SCREEN_SHIFT_X)
#define MENU_SHIFT_Y (56 + SCREEN_SHIFT_Y)
#define MENU_SPACE_Y 12



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Message ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define MESSAGE_COUNT 8
#define MESSAGE_MAXLENGTH 156
#define MESSAGE_MAXSIZE 128
#define MESSAGE_SHIFT_Y (94 + SCREEN_SHIFT_Y)



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Movement ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define MOVEMENT_BULLET_COUNT 6
#define MOVEMENT_SHIP_COUNT 13



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Screen ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define SCREEN_EDGE_BOTTOM (SCREEN_SIZE_VERT - 1)
#define SCREEN_EDGE_LEFT (0)
#define SCREEN_EDGE_RIGHT (SCREEN_SIZE_HORZ - 1)
#define SCREEN_EDGE_TOP (0)
#define SCREEN_FADE 4
#define SCREEN_SHIFT_X Is89(0,40)
#define SCREEN_SHIFT_Y Is89(0,14)
#define SCREEN_SIZE_HORZ (160)
#define SCREEN_SIZE_VERT (100)
#define SCREEN_STATUS_CREDITS_X 2
#define SCREEN_STATUS_CREDITS_Y 2
#define SCREEN_STATUS_LIFE_X 126
#define SCREEN_STATUS_LIFE_Y 2
#define SCREEN_STATUS_SCORE_X 64
#define SCREEN_STATUS_SCORE_Y 2



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Ship ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define SHIP_COUNT 32
#define SHIP_HIT 4
#define SHIP_MAXROWS 6
#define SHIP_MOVE_DONE_X 4
#define SHIP_MOVE_DONE_Y 3
#define SHIP_MOVE_NEXT 0
#define SHIP_MOVE_STATE_X 2
#define SHIP_MOVE_STATE_Y 1
#define SHIP_SIZE (16 << COEF_SCREEN_TO_ZONE)
#define SHIP_SPACE_H (24 << COEF_SCREEN_TO_ZONE)
#define SHIP_SPACE_V (16 << COEF_SCREEN_TO_ZONE)



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Shop ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define SHOP_DESCRIPTION_SHIFT (8 * SHOP_ITEMS_SPACE + SHOP_ITEMS_SHIFT + 2)
#define SHOP_HEADER_SHIFT (2 + SCREEN_SHIFT_Y)
#define SHOP_ITEMS_SHIFT (SHOP_HEADER_SHIFT + 23)
#define SHOP_ITEMS_SPACE 8



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Stars ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define STAR1_COUNT 16
#define STAR1_SIZE (8 << COEF_SCREEN_TO_ZONE)
#define STAR2_SIZE (8 << COEF_SCREEN_TO_ZONE)
#define STAR2_COUNT 16



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Status ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define STATUS_TIME_ANIM 10
#define STATUS_TIME_STAY 70



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Weapon ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define WEAPON_COUNT 10



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Zone ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

#define ZONE_SIZE_HORZ (SCREEN_SIZE_HORZ << COEF_SCREEN_TO_ZONE)
#define ZONE_SIZE_VERT (SCREEN_SIZE_VERT << COEF_SCREEN_TO_ZONE)
#define ZONE_EDGE_BOTTOM (ZONE_SIZE_VERT - 1)
#define ZONE_EDGE_LEFT (0)
#define ZONE_EDGE_RIGHT (ZONE_SIZE_HORZ - 1)
#define ZONE_EDGE_TOP (0)
