////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                   Graphic Functions                    //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^ Defines & Includes ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

//------------------- Header Includes --------------------//

#include "TIGCChdr.h"
#include "Factory.h"
#include "Constants.h"
#include "Aliases.h"
#include "Structures.h"
#include "Prototypes.h"
#include "Globals.h"



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^ Gray Sprite 8x8 OR (Extgraph) ^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void GrayClipSprite8_OR_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned char *sprite asm("%a2"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));
asm(".data
.globl GrayClipSprite8_OR_R
.even

__Pre_loop_GrayClipSprite8_OR_R_2:
    lea      30(%a0),%a0
    lea      30(%a1),%a1
__Loop_GrayClipSprite8_OR_R_2:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
    lsl.w    %d1,%d0
    or.w     %d0,(%a0)

    moveq    #0,%d0
    move.b   (%a3)+,%d0
    lsl.w    %d1,%d0
    or.w     %d0,(%a1)

    dbf      %d2,__Pre_loop_GrayClipSprite8_OR_R_2

    movem.l  (%sp)+,%d3/%a2-%a3
    rts

GrayClipSprite8_OR_R:
    movem.l  %d3/%a2-%a3,-(%sp)

    lea      8(%a2),%a3

    subq.w   #1,%d2		| %d2 = h - 1
    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite8_OR_R	| h > 0 ?

    add.w    %d1,%d2		| %d2 = h + y
    bmi.s    __End_GrayClipSprite8_OR_R		| y + h < 0 ?

    suba.w   %d1,%a2		| sprt0 -= y
    suba.w   %d1,%a3		| sprt1 -= y
    moveq.l  #0,%d1		| offsety = 0
    bra.s    __ClipX_GrayClipSprite8_OR_R

__YPositive_GrayClipSprite8_OR_R:
    subi.w   #127,%d3		| %d3 = y - 128
    bhi.s    __End_GrayClipSprite8_OR_R		| y - 128 > 0 ?
    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite8_OR_R	| h + y - 128 < 0 ?
    sub.w    %d3,%d2		| h -= h + y -128 (h = y - 128)

__CalcOffset_GrayClipSprite8_OR_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15

__ClipX_GrayClipSprite8_OR_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite8_OR_R	| x < 0 ?
    cmpi.w   #239-8,%d0
    bhi.s    __ClipXRight_GrayClipSprite8_OR_R	| x > 239-8

    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    and.w    #0xF,%d0
    moveq    #8,%d1
    sub.w    %d0,%d1
    bge.s    __Loop_GrayClipSprite8_OR_R_2

    neg.w    %d1
__Loop_GrayClipSprite8_OR_R_1:
    moveq    #0,%d0
    move.b   (%a2)+,%d0
    swap.w   %d0
    lsr.l    %d1,%d0
    or.l     %d0,(%a0)

    moveq.l  #0,%d0
    move.b   (%a3)+,%d0
    swap.w   %d0
    lsr.l    %d1,%d0
    or.l     %d0,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite8_OR_R_1
__End_GrayClipSprite8_OR_R:
    movem.l  (%sp)+,%d3/%a2-%a3
    rts

__ClipXLeft_GrayClipSprite8_OR_R:
    cmpi.w   #-8,%d0
    bls.s    __End_GrayClipSprite8_OR_R		| x <= -8 ?

    neg.w    %d0		| shift = -x
    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

__LoopClipL_GrayClipSprite8_OR_R:
    move.b   (%a2)+,%d1
    lsl.b    %d0,%d1		| shifting
    or.b     %d1,(%a0)

    move.b   (%a3)+,%d1
    lsl.b    %d0,%d1		| shifting
    or.b     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopClipL_GrayClipSprite8_OR_R

    movem.l  (%sp)+,%d3/%a2-%a3
    rts

__ClipXRight_GrayClipSprite8_OR_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite8_OR_R		| x > 239

    andi.w   #7,%d0		| shiftx = x & 7
    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #29,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1
__LoopClipR_GrayClipSprite8_OR_R:
    move.b   (%a2)+,%d1
    lsr.b    %d0,%d1
    or.b     %d1,(%a0)

    move.b   (%a3)+,%d1
    lsr.b    %d0,%d1
    or.b     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopClipR_GrayClipSprite8_OR_R

    movem.l  (%sp)+,%d3/%a2-%a3
    rts");



////////////////////////////////////////////////////////////
//^^^^^^^^^^ Gray Sprite 16x16 MASK (Extgraph) ^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void GrayClipSprite16_MASK_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned short *sprt0,unsigned short *sprt1,unsigned short *mask0,unsigned short *mask1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
asm("
.data
.globl GrayClipSprite16_MASK_R
.even

GrayClipSprite16_MASK_R:
    movem.l  %d3/%a2-%a5,-(%sp)

    lea.l    4+20(%sp),%a5
    movea.l  (%a5)+,%a2
    movea.l  (%a5)+,%a3
    movea.l  (%a5)+,%a4
    movea.l  (%a5),%a5

|    move.l   4+20(%sp),%a2
|    move.l   4+20+4(%sp),%a3
|    move.l   4+20+4+4(%sp),%a4
|    move.l   4+20+4+4+4(%sp),%a5

    subq.w   #1,%d2		| %d2 = h - 1

    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite16_MASK_R	| h > 0 ?

    add.w    %d1,%d2		| %d2 = h + y
    bmi.s    __End_GrayClipSprite16_MASK_R		| y + h < 0 ?

    add.w    %d1,%d1		| %d1 = 2y
    suba.w   %d1,%a2		| sprt -= 2y
    suba.w   %d1,%a3
    suba.w   %d1,%a4
    suba.w   %d1,%a5

    moveq.l  #0,%d1		| offsety = 0
    bra.s    __ClipX_GrayClipSprite16_MASK_R

__YPositive_GrayClipSprite16_MASK_R:
    subi.w   #127,%d3		| %d3 = y - 127
    bhi.s    __End_GrayClipSprite16_MASK_R		| y - 127 >= 0 ?

    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite16_MASK_R	| h + y - 128 < 0 ?

    sub.w    %d3,%d2		| h -= h + y -128 (h = y - 128)

__CalcOffset_GrayClipSprite16_MASK_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15

__ClipX_GrayClipSprite16_MASK_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __ClipXLeft_GrayClipSprite16_MASK_R	| x < 0 ?

    cmpi.w   #239-16,%d0
    bhi.w    __ClipXRight_GrayClipSprite16_MASK_R	| x > 239-15

    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    andi.w   #15,%d0
    moveq.l  #16,%d1
    sub.w    %d0,%d1

__Loop_GrayClipSprite16_MASK_R:
    move.l   (%a0),%d3
    moveq.l  #-1,%d0
    move.w   (%a4)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,%d3

    moveq.l  #0,%d0
    move.w   (%a2)+,%d0
    lsl.l    %d1,%d0
    or.l     %d0,%d3
    move.l   %d3,(%a0)

    move.l   (%a1),%d3
    moveq.l  #-1,%d0
    move.w   (%a5)+,%d0
    rol.l    %d1,%d0
    and.l    %d0,%d3

    moveq.l  #0,%d0
    move.w   (%a3)+,%d0
    lsl.l    %d1,%d0
    or.l     %d0,%d3
    move.l   %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite16_MASK_R

__End_GrayClipSprite16_MASK_R:
    movem.l  (%sp)+,%d3/%a2-%a5
    rts

__ClipXLeft_GrayClipSprite16_MASK_R:
    cmpi.w   #-16,%d0
    bls.s    __End_GrayClipSprite16_MASK_R		| x <= -16 ?

    neg.w    %d0		| shift = -x

    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

__LoopClipL_GrayClipSprite16_MASK_R:
    move.w   (%a0),%d3
    moveq.l  #-1,%d1
    move.w   (%a4)+,%d1
    rol.l    %d0,%d1
    and.w    %d1,%d3

    move.w   (%a2)+,%d1
    lsl.w    %d0,%d1		| shifting
    or.w     %d1,%d3
    move.w   %d3,(%a0)

    move.w   (%a1),%d3
    moveq.l  #-1,%d1
    move.w   (%a5)+,%d1
    rol.l    %d0,%d1
    and.w    %d1,%d3

    move.w   (%a3)+,%d1
    lsl.w    %d0,%d1
    or.w     %d1,%d3
    move.w   %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__LoopClipL_GrayClipSprite16_MASK_R

    movem.l  (%sp)+,%d3/%a2-%a5
    rts

__ClipXRight_GrayClipSprite16_MASK_R:
    cmpi.w   #239,%d0
    bhi.s    __End_GrayClipSprite16_MASK_R		| x > 239

    andi.w   #15,%d0		| shiftx = x & 15

    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #28,%d1		| On va au bout de la ligne
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

__LoopClipR_GrayClipSprite16_MASK_R:
    move.w   (%a0),%d3
    moveq.l  #-1,%d1
    move.w   (%a4)+,%d1
    asr.l    %d0,%d1
    and.w    %d1,%d3

    move.w   (%a2)+,%d1
    lsr.w    %d0,%d1
    or.w     %d1,%d3
    move.w   %d3,(%a0)

    move.w   (%a1),%d3
    moveq.l  #-1,%d1
    move.w   (%a5)+,%d1
    asr.l    %d0,%d1
    and.w    %d1,%d3

    move.w   (%a3)+,%d1
    lsr.w    %d0,%d1
    or.w     %d1,%d3
    move.w   %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1

    dbf      %d2,__LoopClipR_GrayClipSprite16_MASK_R

    movem.l  (%sp)+,%d3/%a2-%a5
    rts");



////////////////////////////////////////////////////////////
//^^^^^^^^^^ Gray Sprite 32x32 MASK (Extgraph) ^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void GrayClipSprite32_MASK_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *sprt0,unsigned long *sprt1,unsigned long *mask0,unsigned long *mask1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
asm(".data
.globl GrayClipSprite32_MASK_R
.even

__GrayClipXRight_GrayClipSprite32_MASK_R:
    cmpi.w   #239,%d0
    bhi.s    __End2_GrayClipSprite32_MASK_R		| x > 239
    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #26,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1

    move.w   %d0,%d3
    andi.w   #15,%d0		| shiftx
    cmpi.w   #224,%d3
    blt.s    __Pre_LoopGrayClipR_GrayClipSprite32_MASK_R
    addi.w   #16,%d0
| Note: shift count can be large, therefore the shifting may be quite slow...
__Pre_LoopGrayClipR_GrayClipSprite32_MASK_R:
    moveq.l  #-1,%d3
    lsr.l    %d0,%d3
    not.l    %d3
__LoopGrayClipR_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d1
    lsr.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a0)

    move.l   (%a5)+,%d1
    lsr.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a1)

    move.l   (%a2)+,%d1
    lsr.l    %d0,%d1
    or.l     %d1,(%a0)

    move.l   (%a3)+,%d1
    lsr.l    %d0,%d1
    or.l     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipR_GrayClipSprite32_MASK_R
__End2_GrayClipSprite32_MASK_R:
    movem.l  (%sp)+,%d3/%a2-%a5
    rts

GrayClipSprite32_MASK_R:
    movem.l  %d3/%a2-%a5,-(%sp)

    lea.l    4+20(%sp),%a5
    movea.l  (%a5)+,%a2
    movea.l  (%a5)+,%a3
    movea.l  (%a5)+,%a4
    movea.l  (%a5),%a5

|    move.l   4+20(%sp),%a2
|    move.l   4+20+4(%sp),%a3
|    move.l   4+20+4+4(%sp),%a4
|    move.l   4+20+4+4+4(%sp),%a5

    subq.w   #1,%d2		| %d2 = h - 1
    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite32_MASK_R	| h > 0 ?
    add.w    %d1,%d2		| %d2 = y + h
    bmi.s    __End2_GrayClipSprite32_MASK_R		| y + h < 0 ?
    add.w    %d1,%d1		| %d1 = 2y
    add.w    %d1,%d1		| %d1 = 4y
    suba.w   %d1,%a2		| sprt -= 4y
    suba.w   %d1,%a3
    suba.w   %d1,%a4
    suba.w   %d1,%a5
    moveq.l  #0,%d1		| offsety = 0
    bra.s    __GrayClipX_GrayClipSprite32_MASK_R
__YPositive_GrayClipSprite32_MASK_R:
    subi.w   #127,%d3		| %d3 = y - 128
    bhi.s    __End_GrayClipSprite32_MASK_R		| y - 128 > 0 ?
    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite32_MASK_R	| h + y - 128 < 0 ?
    sub.w    %d3,%d2		| h -= h + y - 128
__CalcOffset_GrayClipSprite32_MASK_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15
__GrayClipX_GrayClipSprite32_MASK_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __GrayClipXLeft_GrayClipSprite32_MASK_R	| x < 0 ?
    cmpi.w   #239-32,%d0
    bhi.w    __GrayClipXRight_GrayClipSprite32_MASK_R	| x > 239-32
    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1
    moveq.l  #16,%d1
    andi.w   #15,%d0		| %d0 = righshift
    sub.w    %d0,%d1		| %d1 = 16 - (x & 15)
    move.w   %d4,-(%sp)
    move.w   %d5,-(%sp)

    moveq.l  #-1,%d3
    lsl.l    %d1,%d3
    move.l   %d3,%d4
    not.l    %d4
__Loop_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    or.w     %d3,%d5
    and.w    %d5,(%a0)+
    or.l     %d4,%d0
    and.l    %d0,(%a0)

    move.l   (%a5)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    or.w     %d3,%d5
    and.w    %d5,(%a1)+
    or.l     %d4,%d0
    and.l    %d0,(%a1)

    move.l   (%a2)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    and.l    %d3,%d0
    or.l     %d0,(%a0)
    and.w    %d4,%d5
    or.w     %d5,-(%a0)

    move.l   (%a3)+,%d0
    rol.l    %d1,%d0
    move.w   %d0,%d5
    and.l    %d3,%d0
    or.l     %d0,(%a1)
    and.w    %d4,%d5
    or.w     %d5,-(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite32_MASK_R
    move.w   (%sp)+,%d5
    move.w   (%sp)+,%d4
__End_GrayClipSprite32_MASK_R:
    movem.l  (%sp)+,%d3/%a2-%a5
    rts

__GrayClipXLeft_GrayClipSprite32_MASK_R:
    cmpi.w   #-32,%d0
    bls.s    __End_GrayClipSprite32_MASK_R		| x <= -32 ?
| Note: shift count can be large, therefore the shifting may be quite slow...
    neg.w    %d0		| shift = -x
    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1

    moveq.l  #-1,%d3
    lsl.l    %d0,%d3
    not.l    %d3
__LoopGrayClipL_GrayClipSprite32_MASK_R:
    move.l   (%a4)+,%d1
    lsl.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a0)

    move.l   (%a5)+,%d1
    lsl.l    %d0,%d1
    or.l     %d3,%d1
    and.l    %d1,(%a1)

    move.l   (%a2)+,%d1
    lsl.l    %d0,%d1		| shifting
    or.l     %d1,(%a0)

    move.l   (%a3)+,%d1
    lsl.l    %d0,%d1		| shifting
    or.l     %d1,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipL_GrayClipSprite32_MASK_R

    movem.l  (%sp)+,%d3/%a2-%a5
    rts");



////////////////////////////////////////////////////////////
//^^^^^^^^^ Gray Sprite 32x32 TRANSW (Extgraph) ^^^^^^^^^^//
////////////////////////////////////////////////////////////

void GrayClipSprite32_TRANW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *sprt0,unsigned long *sprt1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
asm(".data
.globl GrayClipSprite32_TRANW_R
.even

__GrayClipXRight_GrayClipSprite32_TRANW_R:
    cmpi.w   #239,%d0
    bhi.s    __End2_GrayClipSprite32_TRANW_R		| x > 239
    add.w    %d1,%d1		| %d1 = y*30
    addi.w   #26,%d1
    adda.w   %d1,%a0
    adda.w   %d1,%a1

    move.w   %d0,%d3
    andi.w   #15,%d0		| shiftx
    cmpi.w   #224,%d3
    blt.s    __LoopGrayClipR_GrayClipSprite32_TRANW_R
    addi.w   #16,%d0
__LoopGrayClipR_GrayClipSprite32_TRANW_R:
    move.l   (%a2)+,%d1
    lsr.l    %d0,%d1
    move.l   (%a3)+,%d3
    lsr.l    %d0,%d3

    move.l   %d1,%d4
    or.l     %d3,%d4
    not.l    %d4

    and.l    %d4,(%a0)
    and.l    %d4,(%a1)

    or.l     %d1,(%a0)
    or.l     %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipR_GrayClipSprite32_TRANW_R
__End2_GrayClipSprite32_TRANW_R:
    movem.l  (%sp)+,%d3-%d4/%a2-%a3
    rts

GrayClipSprite32_TRANW_R:
    movem.l  %d3-%d4/%a2-%a3,-(%sp)
    
    move.l   4+16(%sp),%a2
    move.l   4+16+4(%sp),%a3
    
    subq.w   #1,%d2		| %d2 = h - 1
    move.w   %d1,%d3		| %d3 = y
    bpl.s    __YPositive_GrayClipSprite32_TRANW_R	| h > 0 ?
    add.w    %d1,%d2		| %d2 = y + h
    bmi.s    __End2_GrayClipSprite32_TRANW_R		| y + h < 0 ?
    add.w    %d1,%d1		| %d1 = 2y
    add.w    %d1,%d1		| %d1 = 4y
    suba.w   %d1,%a2		| sprt -= 4y
    suba.w   %d1,%a3
    moveq.l  #0,%d1		| offsety = 0
    bra.s    __GrayClipX_GrayClipSprite32_TRANW_R
__YPositive_GrayClipSprite32_TRANW_R:
    subi.w   #127,%d3		| %d3 = y - 128
    bhi.s    __End_GrayClipSprite32_TRANW_R		| y - 128 > 0 ?
    add.w    %d2,%d3		| %d3 = h + y - 128
    bmi.s    __CalcOffset_GrayClipSprite32_TRANW_R	| h + y - 128 < 0 ?
    sub.w    %d3,%d2		| h -= h + y - 128
__CalcOffset_GrayClipSprite32_TRANW_R:
    move.w   %d1,%d3
    lsl.w    #4,%d1
    sub.w    %d3,%d1		| %d1 = y*15
__GrayClipX_GrayClipSprite32_TRANW_R:
    move.w   %d0,%d3		| %d3 = x
    bmi.s    __GrayClipXLeft_GrayClipSprite32_TRANW_R	| x < 0 ?
    cmpi.w   #239-32,%d0
    jbhi     __GrayClipXRight_GrayClipSprite32_TRANW_R	| x > 239-32
    lsr.w    #4,%d3		| %d3 = x/16
    add.w    %d3,%d1		| %d3 = x/16 + y*15
    add.w    %d1,%d1		| %d3 = x/8 + y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1
    moveq.l  #16,%d1
    andi.w   #15,%d0		| %d0 = righshift
    sub.w    %d0,%d1		| %d1 = 16 - (x & 15)

    moveq.l  #-1,%d3
    lsl.l    %d1,%d3
    move.l   %d3,%d4
    not.l    %d4

    move.l   %d5,-(%sp)
    move.l   %d6,-(%sp)
    move.w   %d7,-(%sp)
__Loop_GrayClipSprite32_TRANW_R:
    move.l   (%a2)+,%d0
    rol.l    %d1,%d0
    move.l   (%a3)+,%d5
    rol.l    %d1,%d5

    move.l   %d0,%d6
    or.l     %d5,%d6
    not.l    %d6
    move.w   %d6,%d7

    or.w     %d3,%d7
    or.l     %d4,%d6
    and.w    %d7,(%a0)+
    and.w    %d7,(%a1)+
    and.l    %d6,(%a0)
    and.l    %d6,(%a1)
    
    move.w   %d0,%d6
    and.l    %d3,%d0
    or.l     %d0,(%a0)
    and.w    %d4,%d6
    or.w     %d6,-(%a0)

    move.w   %d5,%d7
    and.l    %d3,%d5
    or.l     %d5,(%a1)
    and.w    %d4,%d7
    or.w     %d7,-(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__Loop_GrayClipSprite32_TRANW_R

    move.w   (%sp)+,%d7
    move.l   (%sp)+,%d6
    move.l   (%sp)+,%d5
__End_GrayClipSprite32_TRANW_R:
    movem.l  (%sp)+,%d3-%d4/%a2-%a3
    rts
__GrayClipXLeft_GrayClipSprite32_TRANW_R:
    cmpi.w   #-32,%d0
    bls.s    __End_GrayClipSprite32_TRANW_R		| x <= -32 ?
    neg.w    %d0		| shift = -x
    add.w    %d1,%d1		| %d1 = y*30
    adda.w   %d1,%a0		| dest += offset
    adda.w   %d1,%a1
__LoopGrayClipL_GrayClipSprite32_TRANW_R:
    move.l   (%a2)+,%d1
    lsl.l    %d0,%d1		| shifting
    move.l   (%a3)+,%d3
    lsl.l    %d0,%d3		| shifting

    move.l   %d1,%d4
    or.l     %d3,%d4
    not.l    %d4

    and.l    %d4,(%a0)
    and.l    %d4,(%a1)

    or.l     %d1,(%a0)
    or.l     %d3,(%a1)

    lea.l    30(%a0),%a0
    lea.l    30(%a1),%a1
    dbf      %d2,__LoopGrayClipL_GrayClipSprite32_TRANW_R

    movem.l  (%sp)+,%d3-%d4/%a2-%a3
    rts");



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^ Draw horizontal Line OR ^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LineH_OR(register short x1 asm("%d0"), register short x2 asm("%d1"), register short y asm("%d2"), register void *buffer asm("%a0"))
{
	unsigned short i, j;

	buffer += ((y + y) << 4) - (y + y);

	if (x2 < ((x1 + 8) & ~ 7))
	{
		*(unsigned char *)(buffer + (x1 >> 3)) |= (255 << (7 + (x1 & ~ 7) - x2)) & (255 >> (x1 & 7));
	}
	else
	{
		i = (x1 >> 3);
		j = (x2 >> 3);

		*(unsigned char *)(buffer + i++) |= (unsigned char)(255 >> (x1 & 7));
		*(unsigned char *)(buffer + j) |= (unsigned char)(255 << (7 - (x2 & 7)));

		while (i < j)
			*(unsigned char *)(buffer + i++) = 255;
	}
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^ Draw horizontal Line XOR ^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LineH_XOR(register short x1 asm("%d0"), register short x2 asm("%d1"), register short y asm("%d2"), register void *buffer asm("%a0"))
{
	unsigned short i, j;

	buffer += ((y + y) << 4) - (y + y);

	if (x2 < ((x1 + 8) & ~ 7))
	{
		*(unsigned char *)(buffer + (x1 >> 3)) |= (255 << (7 + (x1 & ~ 7) - x2)) & (255 >> (x1 & 7));
	}
	else
	{
		i = (x1 >> 3);
		j = (x2 >> 3);

		*(unsigned char *)(buffer + i++) ^= (unsigned char)(255 >> (x1 & 7));
		*(unsigned char *)(buffer + j) ^= (unsigned char)(255 << (7 - (x2 & 7)));

		while (i < j)
			*(unsigned char *)(buffer + i++) ^= 255;
	}
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^ Draw vertical Line OR ^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LineV_OR(register short x asm("%d0"),register short y1 asm("%d1"),register short y2 asm("%d2"),register void *plane asm("%a0"))
{
	register unsigned char mask = (128 >> (x & 7));

	plane += ((y1 + y1) << 4) - (y1 + y1) + (x >> 3);

	while ((y1++) <= y2)
	{
		*(unsigned char *)plane |= mask;
		plane += 30;
	}
}
