////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                Bullets & Ships locations               //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^ Defines & Includes ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

//------------------- Header Includes --------------------//

#include "TIGCChdr.h"
#include "Factory.h"
#include "Constants.h"
#include "Aliases.h"
#include "Structures.h"
#include "Prototypes.h"
#include "Globals.h"



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n1 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletPulsar(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 0:
			bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;

		case 1:
			bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 2:
			if (bullet->count == 1)
			{
				bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
			}
			else
			{
				bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
				bullet->xSpeed = (bullet->count ? 8 : - 8);
			}
		break;

		case 3:
			bullet->x += (bullet->count < 2 ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
			bullet->xSpeed = (bullet->count & 1 ? 8 : - 8);
		break;
	}

	bullet->ySpeed = (bullet->way ? 64 : - 64);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n2 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletPlasma(struct WORLD *world, struct BULLET *bullet)
{
	bullet->y += (bullet->way ? (bullet->count << 1) : - (bullet->count << 1)) << COEF_SCREEN_TO_ZONE;
	bullet->ySpeed = (bullet->way ? 64 : - 64);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n3 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletFlame(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 2:
			bullet->xSpeed = (bullet->count ? 4 : - 4);
		break;

		case 3:
			if (bullet->count != 1)
				bullet->xSpeed = (bullet->count ? 4 : - 4);
		break;
	}

	bullet->ySpeed = (bullet->way ? 32 : - 32);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n4 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletFire(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 0:
			bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;

		case 1:
			bullet->x += ((bullet->shot & 1) ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 2:
			if (bullet->count == 1)
				bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
			else
				bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 3:
			if (bullet->shot & 1)
				bullet->x += (bullet->count ? 3 : - 3) << COEF_SCREEN_TO_ZONE;
			else
				bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;
	}

	bullet->ySpeed = (bullet->way ? 64 : - 64);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n5 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletHydra(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 0:
		case 1:
			if ((bullet->shot & 15) < 8)
				bullet->xSpeed = ((bullet->shot & 7) - 4) << 2;
			else
				bullet->xSpeed = (4 - (bullet->shot & 7)) << 2;

			bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;

		case 2:
			if ((!!bullet->count) == ((bullet->shot & 15) < 8))
				bullet->xSpeed = ((bullet->shot & 7) - 4) << 3;
			else
				bullet->xSpeed = (4 - (bullet->shot & 7)) << 3;

			bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 3:
			if (bullet->count == 1)
			{
				bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
			}
			else
			{
				if ((!!bullet->count) == ((bullet->shot & 15) < 8))
					bullet->xSpeed = ((bullet->shot & 7) - 4) << 3;
				else
					bullet->xSpeed = (4 - (bullet->shot & 7)) << 3;

				bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
			}
		break;
	}

	bullet->ySpeed = (bullet->way ? 64 : - 64);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n6 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletRay(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 1:
		case 3:
			bullet->x += ((bullet->shot & 1) ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
			bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;

		case 2:
			if (bullet->shot & 1)
				bullet->x += ((bullet->shot & 2) ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
			else
				bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;
	}

	bullet->ySpeed = (bullet->way ? 64 : - 64);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n7 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletBlade(struct WORLD *world, struct BULLET *bullet)
{
	switch (bullet->level)
	{
		case 0:
			bullet->xSpeed = (bullet->count ? 8 : - 8);		
		break;

		case 1:
			if (bullet->count < 2)
			{
				bullet->x += ((bullet->count & 1) ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
				bullet->xSpeed = ((bullet->count & 1) ? 8 : - 8);
			}
			else
			{
				bullet->xSpeed = ((bullet->count & 1) ? 4 : - 4);
			}
		break;

		case 2:
		case 3:
			if (bullet->count < 2)
			{
				bullet->x += ((bullet->count & 1) ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
				bullet->xSpeed = ((bullet->count & 1) ? 16 : - 16);
			}
			else if (bullet->count < 4)
			{
				bullet->x += ((bullet->count & 1) ? 4 : - 4) << COEF_SCREEN_TO_ZONE;
				bullet->xSpeed = ((bullet->count & 1) ? 8 : - 8);
			}
			else
			{
				bullet->xSpeed = ((bullet->count & 1) ? 4 : - 4);
			}
		break;
	}

	bullet->ySpeed = (bullet->way ? - 16 : 16);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n8 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletHoming(struct WORLD *world, struct BULLET *bullet)
{
	unsigned short i = world->shipCount;

	switch (bullet->level)
	{
		case 0:
			bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
		break;

		case 1:
			bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 2:
			if (bullet->count == 1)
				bullet->y += (bullet->way ? 8 : - 8) << COEF_SCREEN_TO_ZONE;
			else
				bullet->x += (bullet->count ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
		break;

		case 3:
			if (bullet->count < 2)
				bullet->x += ((bullet->count & 1) ? 6 : - 6) << COEF_SCREEN_TO_ZONE;
			else
				bullet->x += ((bullet->count & 1) ? 3 : - 3) << COEF_SCREEN_TO_ZONE;
		break;
	}

	bullet->count = Random() % world->shipCount;

	while ((--i) && (bullet->way == world->shipList[bullet->count].way))
	{
		if (++bullet->count == world->shipCount)
			bullet->count = 0;
	}

	bullet->ySpeed = (bullet->way ? 32 : - 32);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Weapon n9 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletSide(struct WORLD *world, struct BULLET *bullet)
{
	unsigned short i = world->shipCount;

	bullet->count = Random() % world->shipCount;

	while ((--i) && (bullet->way == world->shipList[bullet->count].way))
	{
		if (++bullet->count == world->shipCount)
			bullet->count = 0;
	}

	if (bullet->x < world->shipList[bullet->count].x)
		bullet->xSpeed = 32;
	else if (bullet->x > world->shipList[bullet->count].x)
		bullet->xSpeed = - 32;
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^ Weapon n10 ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletInstant(struct WORLD *world, struct BULLET *bullet)
{
	bullet->ySpeed = (bullet->way ? 128 : - 128);
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^ Box ship formation ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateShipBox(struct WORLD *world, struct SHIP *ship)
{
	unsigned short col, cols, row, rows;

	rows = ((ship->total - 1) / SHIP_MAXROWS) + 1;
	cols = ship->total / rows;

	row = ship->count / cols;
	col = ship->count % cols;

	if (row > rows - 2)
	{
		if (row > rows - 1)
		{
			col += cols;
			row = rows - 1;
		}

		cols += ship->total - (cols * rows);
	}

	ship->x = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1) - (((cols - 1) * SHIP_SPACE_H) >> 1) + (col * SHIP_SPACE_H);
	ship->xStart = ship->x;
	ship->y = ((row - rows + 1) * SHIP_SPACE_V) - SHIP_SIZE;
	ship->yStart = row * SHIP_SPACE_V;
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^ Left column formation ^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateShipColumnLeft(struct WORLD *world, struct SHIP *ship)
{
	ship->x = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1) - 1024;
	ship->xStart = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1);
	ship->y = - ship->count * SHIP_SPACE_V - SHIP_SIZE;
	ship->yStart = 0;
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^ Right column formation ^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateShipColumnRight(struct WORLD *world, struct SHIP *ship)
{
	ship->x = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1) + 1024;
	ship->xStart = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1);
	ship->y = - ship->count * SHIP_SPACE_V - SHIP_SIZE;
	ship->yStart = 0;
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^ Line formation ^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateShipLine(struct WORLD *world, struct SHIP *ship)
{
	ship->x = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1) - (((ship->total - 1) * SHIP_SPACE_H) >> 1) + (ship->count * SHIP_SPACE_H);
	ship->xStart = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1);
	ship->y = - SHIP_SIZE;
	ship->yStart = 0;
}



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^ Single ship at bottom ^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateShipHuman(struct WORLD *world, struct SHIP *ship)
{
	ship->x = (80 << COEF_SCREEN_TO_ZONE) - (SHIP_SIZE >> 1);
	ship->xStart = ship->x;
	ship->y = 100 << COEF_SCREEN_TO_ZONE;	
	ship->yStart = 0;
}
