////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                       Prototypes                       //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Venus.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void _main(void);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Addons.c ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char AddonCreate(struct WORLD *, unsigned short);
unsigned char AddonDestroy(struct WORLD *, unsigned short);
void AddonUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Bonus.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char BonusCreate(struct WORLD *, unsigned short, unsigned short, unsigned short);
unsigned char BonusDestroy(struct WORLD *, unsigned short);
void BonusUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Bullets.c ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char BulletCreate(struct WORLD *, unsigned short, unsigned short, unsigned short, unsigned short, unsigned char, unsigned char, unsigned char);
unsigned char BulletDestroy(struct WORLD *, unsigned short);
void BulletUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Effects.c ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char EffectCreate(struct WORLD *, unsigned short, unsigned short, unsigned short);
unsigned char EffectDestroy(struct WORLD *, unsigned short);
void EffectUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Events.c ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

inline unsigned char EventInit(struct WORLD *);
inline unsigned char EventLoad(struct WORLD *, const unsigned char *);
inline unsigned char EventProceed(struct WORLD *);
inline unsigned char EventSave(struct WORLD *, const unsigned char *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Game.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

inline unsigned char Game(struct WORLD *, unsigned char);
void EraseBorder(void *);
unsigned short Random(void);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Graph.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void GrayClipSprite8_OR_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),register unsigned char *sprite asm("%a2"),register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__regparm__(6)));
void GrayClipSprite16_MASK_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned short *sprt0,unsigned short *sprt1,unsigned short *mask0,unsigned short *mask1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
void GrayClipSprite32_MASK_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *sprt0,unsigned long *sprt1,unsigned long *mask0,unsigned long *mask1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
void GrayClipSprite32_TRANW_R(register short x asm("%d0"),register short y asm("%d1"),register short h asm("%d2"),unsigned long *sprt0,unsigned long *sprt1,register void *dest0 asm("%a0"),register void *dest1 asm("%a1")) __attribute__((__stkparm__));
void LineH_OR(register short asm("%d0"), register short asm("%d1"), register short asm("%d2"), register void * asm("%a0"));
void LineH_XOR(register short asm("%d0"), register short asm("%d1"), register short asm("%d2"), register void * asm("%a0"));
void LineV_OR(register short asm("%d0"), register short asm("%d1"), register short asm("%d2"), register void * asm("%a0"));



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^ Locations.c ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void LocateBulletPulsar(struct WORLD *, struct BULLET *);
void LocateBulletPlasma(struct WORLD *, struct BULLET *);
void LocateBulletFlame(struct WORLD *, struct BULLET *);
void LocateBulletFire(struct WORLD *, struct BULLET *);
void LocateBulletHydra(struct WORLD *, struct BULLET *);
void LocateBulletRay(struct WORLD *, struct BULLET *);
void LocateBulletBlade(struct WORLD *, struct BULLET *);
void LocateBulletHoming(struct WORLD *, struct BULLET *);
void LocateBulletSide(struct WORLD *, struct BULLET *);
void LocateBulletInstant(struct WORLD *, struct BULLET *);
void LocateShipBox(struct WORLD *world, struct SHIP *);
void LocateShipColumnLeft(struct WORLD *, struct SHIP *);
void LocateShipColumnRight(struct WORLD *, struct SHIP *);
void LocateShipLine(struct WORLD *, struct SHIP *);
void LocateShipHuman(struct WORLD *, struct SHIP *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Menu.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

inline unsigned char Menu(struct WORLD *);
inline unsigned char MenuSelect(struct WORLD *, unsigned char (*)[16], unsigned short, unsigned short, unsigned char);
inline void MenuUpdate(struct WORLD *, unsigned char (*)[16], unsigned short, unsigned short, unsigned short, signed short);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^ Messages.c ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char MessageCreate(struct WORLD *, const unsigned char *, unsigned char);
void MessageUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^ Movements.c ^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char MoveBulletStraight(struct WORLD *, struct BULLET *);
unsigned char MoveBulletShift(struct WORLD *, struct BULLET *);
unsigned char MoveBulletFade(struct WORLD *, struct BULLET *);
unsigned char MoveBulletReverse(struct WORLD *, struct BULLET *);
unsigned char MoveBulletFollow(struct WORLD *, struct BULLET *);
unsigned char MoveBulletLateral(struct WORLD *, struct BULLET *);
unsigned char MoveShipHuman(struct WORLD *, struct SHIP *);
unsigned char MoveShipLosangeLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipLosangeRight(struct WORLD *, struct SHIP *);
unsigned char MoveShipPatrolLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipPatrolRight(struct WORLD *, struct SHIP *);
unsigned char MoveShipRotateLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipRotateRight(struct WORLD *, struct SHIP *);
unsigned char MoveShipSquareLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipSquareRight(struct WORLD *, struct SHIP *);
unsigned char MoveShipEightLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipEightRight(struct WORLD *, struct SHIP *);
unsigned char MoveShipCrossLeft(struct WORLD *, struct SHIP *);
unsigned char MoveShipCrossRight(struct WORLD *, struct SHIP *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Ships.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char ShipCreate(struct WORLD *, unsigned short, unsigned short, unsigned short, unsigned char);
unsigned char ShipDestroy(struct WORLD *, unsigned short);
unsigned char ShipMoveAuto(struct WORLD *, struct SHIP *, signed short (*)[4], unsigned short, unsigned short);
unsigned char ShipMoveHuman(struct WORLD *, struct SHIP *);
void ShipUpdate(struct WORLD *);
void ShipWeapon(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Shop.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

unsigned char Shop(struct WORLD *);
inline void ShopDraw(struct WORLD *, unsigned char *, unsigned short, unsigned short *, unsigned char);
inline void ShopIndic(struct WORLD *, unsigned short, unsigned short, unsigned char);
inline unsigned char ShopSelect(struct WORLD *, unsigned short *);


////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Status.c ^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

inline void StatusCredits(struct WORLD *);
inline void StatusLife(struct WORLD *);
inline void StatusScore(struct WORLD *);
void StatusShow(unsigned short *);
void StatusUpdate(struct WORLD *);



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ World.c ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

inline unsigned char WorldCreate(struct WORLD *);
inline void WorldFree(struct WORLD *);
void WorldCycle(struct WORLD *);
void WorldInit(struct WORLD *);
void WorldUpdate(struct WORLD *);
