////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                       Structures                       //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^ Declarations ^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct WORLD;



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Addon ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct ADDON
{
	unsigned short time, type;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Bonus ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct BONUS
{
	signed short x, y;
	unsigned short sprite, value;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Bullet ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct BULLET
{
	unsigned char effect, level, shot, way;
	signed short damage, radius, x, xSpeed, y, ySpeed;
	unsigned short count, movement, sprite, total;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Effects ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct EFFECT
{
	signed short x, y;
	unsigned short length, sprite, time;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Fleet ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct FLEET
{
	signed char life;
	unsigned char effect;
	signed short radius;
	unsigned short sprite, weapon;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^ Message ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct MESSAGE
{
	const unsigned char *str;
	unsigned char state;
	unsigned short end, pause, start;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^^ Ship ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct SHIP
{
	unsigned char effect, hit, pos, shot, way;
	signed short life, radius, speedAdd, speedMax, x, xSpeed, xStart, y, ySpeed, yStart;
	unsigned short count, fire, movement, reload, sprite, step, total, weapon;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ World ^^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct WORLD
{
// Fields that must be saved
	unsigned char	eventEndArg, eventEndType;
	unsigned short	addonCount, bonusCount, bulletCount, effectCount, messageCount, shipCount,
					eventIndex, messageIndex, messageStep,
					starAccel, starSpeed,
					statusCredits, statusLife, statusScore,
					credits, score;
	unsigned long	time;

// Fields that will be recreated
	unsigned char	*eventPtr,
					keyReleased[10],
					level[9],
					addonLevel[ADDON_COUNT], weaponLevel[WEAPON_COUNT],
					fade;
	signed short	(*star1)[2], (*star2)[2];
	unsigned short	lost;
	unsigned long	eventId,
					keyDelay[8];
	void *buffer, *dark, *light;
	struct ADDON *addonList;
	struct BONUS *bonusList;
	struct BULLET *bulletList;
	struct EFFECT *effectList;
	struct MESSAGE *messageList;
	struct SHIP *shipList;
};



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^^^^^ Weapon ^^^^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

struct WEAPON
{
	unsigned char effect;
	signed short damage, radius, xShift, yShift;
	unsigned short count, location, movement, reload, sprite;
};
