////////////////////////////////////////////////////////////
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
//                         Venus                          //
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~//
////////////////////////////////////////////////////////////



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^ Defines & Includes ^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

//------------------- Header Includes --------------------//

#include "TIGCChdr.h"
#include "Factory.h"
#include "Constants.h"
#include "Aliases.h"
#include "Structures.h"
#include "Prototypes.h"
#include "Globals.h"



////////////////////////////////////////////////////////////
//^^^^^^^^^^^^^^^^^^^^ Main function ^^^^^^^^^^^^^^^^^^^^^//
////////////////////////////////////////////////////////////

void _main(void)
{
	struct WORLD world;

//------- Initialisation, Grays, Interruptions... --------//

	if ((FC_Start(FC_Redirect | FC_Gray | FC_SaveScreen | FC_4x6))
	 && (WorldCreate(&world)))
	{
		randomize();
		randSeed = rand();

		Menu(&world);

		WaitRelease(b1);
		WaitRelease(esc);
		FC_Stop();

		ST_helpMsg("\017 Thanks for playing ^^");
	}

//--------------------- Fatal error ----------------------//
	else
	{
		ST_helpMsg("\016 Error, not enough RAM");
	}

//------------------ Free memory, quit -------------------//

	WorldFree(&world);
}
